package com.addressbook;

public class AddressBookProxy implements com.addressbook.AddressBook {
  private boolean _useJNDI = true;
  private String _endpoint = null;
  private com.addressbook.AddressBook addressBook = null;
  
  public AddressBookProxy() {
    _initAddressBookProxy();
  }
  
  private void _initAddressBookProxy() {
  
  if (_useJNDI) {
    try{
      javax.naming.InitialContext ctx = new javax.naming.InitialContext();
      addressBook = ((com.addressbook.AddressBookService)ctx.lookup("java:comp/env/service/AddressBookService")).getAddressBookPort();
      }
    catch (javax.naming.NamingException namingException) {}
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  if (addressBook == null) {
    try{
      addressBook = (new com.addressbook.AddressBookServiceLocator()).getAddressBookPort();
      }
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  if (addressBook != null) {
    if (_endpoint != null)
      ((javax.xml.rpc.Stub)addressBook)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
    else
      _endpoint = (String)((javax.xml.rpc.Stub)addressBook)._getProperty("javax.xml.rpc.service.endpoint.address");
  }
  
}


public void useJNDI(boolean useJNDI) {
  _useJNDI = useJNDI;
  addressBook = null;
  
}

public String getEndpoint() {
  return _endpoint;
}

public void setEndpoint(String endpoint) {
  _endpoint = endpoint;
  if (addressBook != null)
    ((javax.xml.rpc.Stub)addressBook)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
  
}

public com.addressbook.AddressBook getAddressBook() {
  if (addressBook == null)
    _initAddressBookProxy();
  return addressBook;
}

public void saveAddress(com.addressbook.PersonType person) throws java.rmi.RemoteException{
  if (addressBook == null)
    _initAddressBookProxy();
  addressBook.saveAddress(person);
}

public com.addressbook.AddressType findAddress(java.lang.String name) throws java.rmi.RemoteException, com.addressbook.FindAddressFaultType{
  if (addressBook == null)
    _initAddressBookProxy();
  return addressBook.findAddress(name);
}


}