#!/bin/sh
# Author: Barry Searle
#
# (C) Copyright IBM Corp. 2004 - All Rights Reserved.
# DISCLAIMER:
# The following source code is sample code created by IBM Corporation.
# This sample code is not part of any standard IBM product and is provided
# to you solely for the purpose of assisting you in the development of your
# applications. The code is provided 'AS IS', without warranty or condition
# of any kind. IBM shall not be liable for any damages arising out of your
# use of the sample code, even if IBM has been advised of the possibility of
# such damages.
#
# Change History:
# 1.2 (14jan2005) reordered parameters
# 1.1 (17nov2004) initial version
#


binDir=`dirname "$0"`
pwd=`pwd`
if [ $binDir = "." ]
then
  binDir=$pwd
fi

# ########## ONLY 'WAS_ROOT' MUST BE SET ########
WAS_ROOT=/opt/IBM/WAS60/AppServer/profiles/ND6

# ########## no longer needed ########
#JACLWASROOT=$WAS_ROOT
#JACLbaseDir=$binDir
#distDir=$JACLbaseDir/dist

DEPLOY_ROOT=$binDir
DEPLOY_DIST=$binDir/dist
DEPLOY_WAS=$WAS_ROOT
DEPLOY_STAGE=-pilot
DEPLOY_FAIL=true
DEPLOY_ACTION=install
script=$DEPLOY_ROOT/automatedDeploy.jacl

if [ "$1" = "ant" ]; then
  # ########## edit automatedDeploy.xml  to set WASROOT location ##########
  ../../runAnt.sh -buildfile ./automatedDeploy.xml
else
  echo FIRST install ...
  "$WAS_ROOT/bin/wsadmin.sh" -f "$script"  $DEPLOY_ACTION  $DEPLOY_STAGE  $DEPLOY_FAIL  "$DEPLOY_DIST"  "$DEPLOY_WAS"

  echo SECOND update ...
  "$WAS_ROOT/bin/wsadmin.sh" -f "$script"  update          $DEPLOY_STAGE  $DEPLOY_FAIL  "$DEPLOY_DIST"  "$DEPLOY_WAS"

  echo .
  echo THIRD confirm ...
  "$WAS_ROOT/bin/wsadmin.sh" -f "$script"  confirm         $DEPLOY_STAGE  false         "$DEPLOY_DIST"  "$DEPLOY_WAS"

  echo FOURTH  uninstall ...
  "$WAS_ROOT/bin/wsadmin.sh" -f "$script"  uninstall       $DEPLOY_STAGE  $DEPLOY_FAIL  "$DEPLOY_DIST"  "$DEPLOY_WAS"

  echo DONE.
fi
