package stockquote;

public class StockQuoteServiceProxy implements stockquote.StockQuoteService {
  private boolean _useJNDI = true;
  private String _endpoint = null;
  private stockquote.StockQuoteService stockQuoteService = null;
  
  public StockQuoteServiceProxy() {
    _initStockQuoteServiceProxy();
  }
  
  private void _initStockQuoteServiceProxy() {
  
  if (_useJNDI) {
    try{
      javax.naming.InitialContext ctx = new javax.naming.InitialContext();
      stockQuoteService = ((stockquote.StockQuoteServiceService)ctx.lookup("java:comp/env/service/StockQuoteServiceService")).getStockQuoteService();
      }
    catch (javax.naming.NamingException namingException) {}
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  if (stockQuoteService == null) {
    try{
      stockQuoteService = (new stockquote.StockQuoteServiceServiceLocator()).getStockQuoteService();
      }
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  if (stockQuoteService != null) {
    if (_endpoint != null)
      ((javax.xml.rpc.Stub)stockQuoteService)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
    else
      _endpoint = (String)((javax.xml.rpc.Stub)stockQuoteService)._getProperty("javax.xml.rpc.service.endpoint.address");
  }
  
}


public void useJNDI(boolean useJNDI) {
  _useJNDI = useJNDI;
  stockQuoteService = null;
  
}

public String getEndpoint() {
  return _endpoint;
}

public void setEndpoint(String endpoint) {
  _endpoint = endpoint;
  if (stockQuoteService != null)
    ((javax.xml.rpc.Stub)stockQuoteService)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
  
}

public stockquote.StockQuoteService getStockQuoteService() {
  if (stockQuoteService == null)
    _initStockQuoteServiceProxy();
  return stockQuoteService;
}

public float getQuote(java.lang.String symbol) throws java.rmi.RemoteException{
  if (stockQuoteService == null)
    _initStockQuoteServiceProxy();
  return stockQuoteService.getQuote(symbol);
}


}