/**
 * <copyright>
 *
 * IBM Confidential
 *
 * OCO Source Materials
 * IBM Visual XML Tools
 * (C) Copyright IBM Corp. 2000.
 * The source code for this program is not published or otherwise
 * divested of its trade secrets, irrespective of
 * what has been deposited with the U.S. Copyright Office.
 *
 * </copyright>
 *
 * %W%
 *
 * @version %I% %H%
 */

package com.ibm.etools.xml.util;

import com.ibm.etools.b2b.util.*;
import com.ibm.etools.xml.*;
import com.ibm.etools.grammar.*;
import java.util.*;

/**
 *
 *
 */
public class XMLAttributeValidator
{
  public static String getDefaultAttributeValue(GrammarAttribute grammarAttribute)
  {
    String result = null;

    String defaultValue = grammarAttribute.getDefaultValue();
    if (defaultValue != null)
    {
      result = defaultValue;
    }

    if (result == null)
    {
      Collection c = grammarAttribute.getEnumeratedValues();
      if (c.size() > 0)
      {
        result = (String)c.iterator().next();
      }
    }

    if (result == null)
    {
      result =  "value";
    }

    return result;
  }

  /**
  public static String VALUE_TO_BE_DETERMINED = "";
  protected XMLFile file;



  public static void validateAttributes(XMLFile file)
  {
    XMLAttributeValidator validator = new XMLAttributeValidator(file);
    validator.validate();
  }

  public XMLAttributeValidator(XMLFile file)
  {
    this.file = file;
  }

  public void validate()
  {
    ValueVisitor visitor = new ValueVisitor();
    visitor.visitXMLFile(file);
    visitor.complete();
  }
  */
  /**
   *
   *
  class ValueVisitor extends XMLVisitor
  {
    String baseName = "attr";
    int maxNumber = -1;
    Hashtable idTable = new Hashtable();
    Vector valueToBeDeterminedList = new Vector();
    Vector valueDeterminedList = new Vector();
    Vector idRefList = new Vector();
    Vector idRefsList = new Vector();

    public void updateMaxNumberIfRequired(String value)
    {
      if (value.startsWith(baseName))
      {
        String numberPart = value.substring(baseName.length());
        try
        {
          int n = Integer.parseInt(numberPart);
          maxNumber = Math.max(maxNumber, n);
        }
        catch (Exception e)
        {
        }
      }
    }

    public void visitXMLAttribute(XMLAttribute xmlAttribute)
    {
      DTDAttribute dtdAttribute = xmlAttribute.getDTDAttribute();
      DTDType type = dtdAttribute.getDTDType();
      if (type instanceof DTDBasicType)
      {
        int theKind = ((DTDBasicType)type).getKind();
        if (theKind == DTDBasicTypeKind.ID)
        {
          String value = xmlAttribute.getValue();
          if (value == VALUE_TO_BE_DETERMINED)
          {
            valueToBeDeterminedList.addElement(xmlAttribute);
          }
          else if (value != null && value.length() > 0)
          {
            if (idTable.get(value) == null)
            {
              idTable.put(value, xmlAttribute);
              valueDeterminedList.addElement(xmlAttribute);
              updateMaxNumberIfRequired(value);
            }
            else
            {
              // this value is a duplicate so set it's error flag
            }
          }
          else
          {
            // this value is in error so set it's error flag
          }
        }
        else if (theKind == DTDBasicTypeKind.IDREF |
                 theKind == DTDBasicTypeKind.IDREFS)
        {
          idRefList.addElement(xmlAttribute);
        }
        //else if (theKind == DTDBasicTypeKind.IDREFS)
        //{
          // todo add refs to their own list?
        //  idRefList.addElement(xmlAttribute);
        //}
      }
    }

    public void complete()
    {
      // create unique ID's for the valueToBeDeterminedList elements
      //
      int n = maxNumber;
      for (Enumeration e = valueToBeDeterminedList.elements(); e.hasMoreElements();)
      {
        n++;
        XMLAttribute xmlAttribute = (XMLAttribute)e.nextElement();
        String value = baseName + n;
        xmlAttribute.setValue(value);
        idTable.put(value, xmlAttribute);
        valueDeterminedList.addElement(xmlAttribute);
      }

      String defaultValue = VALUE_TO_BE_DETERMINED;
       if (valueDeterminedList.size() > 0)
      {
        XMLAttribute xmlAttribute = (XMLAttribute)valueDeterminedList.elementAt(0);
        defaultValue = xmlAttribute.getValue();
      }

      // set 'VALUE_TO_BE_DETERMINED' idRefs
      // check the validity of the other idRefs marking error as required
      //
      for (Enumeration e = idRefList.elements(); e.hasMoreElements();)
      {
        XMLAttribute xmlAttribute = (XMLAttribute)e.nextElement();
        String value = xmlAttribute.getValue();

        if (value == VALUE_TO_BE_DETERMINED)
        {
          // create a default value for this attribute
          if (defaultValue != VALUE_TO_BE_DETERMINED)
          {
            xmlAttribute.setValue(defaultValue);
          }
          else
          {
            // there exists no ids for this attribute to reference so set it's error flag
          }
        }
        else if (value != null && value.length() > 0)
        {
          if (idTable.get(value) == null)
          {
            // this value is in error so set it's error flag
          }
        }
        else
        {
          // this value is in error so set it's error flag
        }
      }
    }
  }*/
}
