@rem  ====================================================================================
@rem  Licensed Materials - Property of IBM                                                
@rem  IBM WebSphere SDK for Web Services, Version 5.0                                   
@rem  (C) Copyright IBM Corp. 2002,2003. All Rights Reserved                              
@rem  US Govt. Users Restricted Rights                                                    
@rem  Use duplication or disclosure restricted by GSA ADP Schedule Contract with IBM Corp.
@rem  ====================================================================================

@echo off

IF "%IBM_WSSTUDIO_BIN%" == "" call "%~dp0\setupenv.bat"

IF "%IBM_WSSTUDIO_TYPE%" == "" call "%~dp0\setupenv.bat"

REM Setup location of the appserver and WSDK tools
set wstoolsPluginDir=%IBM_WSSTUDIO_BIN%..\rwd\eclipse\plugins

REM Initialise the arguments
set args=

REM Find the classpath
set CP=
set FULLSTRING=%*
REM Substitute the string "###" to each occurence of the semicolon
set FULLSTRING=%FULLSTRING:;=###%
REM Invoke a subroutine passing the modified string of parameters
call :SUB1 %FULLSTRING%

REM Get back the classpath 
set usrClassPath=%CP%
set foundProject=false

:beginLoop
REM Check if no more arguments to be parsed
if "" == "%1" goto callJavaClass

REM Check if it is the project name
if %1 == -project goto foundProject

REM Check if it is the classpath
if %1 == -cp goto foundClassPath

:continueLoop
set args=%args% %1
shift
goto beginLoop


:foundProject
if %foundProject%==true goto continueLoop
REM remove quotes from PROJECTDIR (similar to PROJECTDIR=%~2)
set PROJECTDIR=%2
set PROJECTDIR=%PROJECTDIR:"=%
if not exist "%~dp1%PROJECTDIR%" mkdir "%~dp1%PROJECTDIR%"
if not exist "%~dp1%PROJECTDIR%\WEB-INF" mkdir "%~dp1%PROJECTDIR%\WEB-INF"
if not exist "%~dp1%PROJECTDIR%\WEB-INF\classes" mkdir "%~dp1%PROJECTDIR%\WEB-INF\classes"
set usrClassPath=%~dp1%PROJECTDIR%\WEB-INF\classes;%usrClassPath%
set foundProject=true
goto continueLoop

:foundClassPath
REM Need to skip until next arg found
shift
if "" == "%1" goto beginLoop
if %1==%next% goto beginLoop
goto foundClassPath


:callJavaClass
REM Set up some environment variables
REM Call the Bean2WebService class with all the arguments and necessary classpath through the Delegateclass in order to bypass classpath length limitation
"%IBM_WSSTUDIO_BIN%..\eclipse\jre\bin\java" -cp "%wstoolsPluginDir%\com.ibm.etools.webservice.was.creation.core_6.0.2.4\runtime\delegate.jar;%wstoolsPluginDir%\com.ibm.etools.webservice.was.creation.core.j2ee13_6.0.2.1\lib\commons-logging-api.jar;%usrClassPath%" -Dwsdk.app.server.home="%IBM_WSSTUDIO_BIN%..\runtimes\%IBM_WSSTUDIO_TYPE%_v51_stub" -Dwsad.wsdk.properties="%wstoolsPluginDir%\com.ibm.etools.webservice.was.creation.core.j2ee13_6.0.2.1\properties\wsdk.properties" -DWSAD_DIR="%IBM_WSSTUDIO_BIN%..\rwd\eclipse" com.ibm.wsdk.delegate.DelegateClass "%wstoolsPluginDir%\com.ibm.etools.webservice.was.creation.core.j2ee13_6.0.2.1\%IBM_WSSTUDIO_TYPE%_cp\ws_cmdlineCP.txt" com.ibm.wsdk.tools.tasks.console.Bean2WebService bean2webservice -wsad %*

REM Subroutine to parse the classpath
REM --------------------------------- 
:SUB1

:LOOP

REM Check if there are parameters left
if {%1}=={} GOTO :EOF

REM Look for the "-cp" flag
if /I {%1}=={-cp} goto :FOUND

REM Shift the parameters for the looping
shift

GOTO :LOOP

:FOUND

REM After "-cp" there must be the path now without semi-colon
REM remove quotes from CP (similar to CP=%~2)
set CP=%2
set CP=%CP:"=%

REM Add back the semicolon
set CP=%CP:###=;%

REM Add the classpath to the arguments
set args=-cp "%CP%;"
set next=%3%

REM Return the subroutine
goto :EOF

:END
@echo on
REM Run setupenv.bat to set the environment variable IBM_WSSTUDIO_BIN



